package user

import (
	errs "backend/pkg/library/errors"
	"net/http"

	"backend/internal/logic/user"
	"backend/internal/svc"
	"backend/internal/types"

	"github.com/zeromicro/go-zero/rest/httpx"
)

// 取得當前登入的會員資訊(自己)
func GetUserInfoHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.Authorization
		if err := httpx.Parse(r, &req); err != nil {
			e := errs.InputInvalidFormatError(err.Error())
			httpx.WriteJsonCtx(r.Context(), w, e.HTTPStatus(), types.Resp{
				Code:    e.DisplayCode(),
				Message: err.Error(),
			})

			return
		}

		//if err := svcCtx.Validate.ValidateAll(req); err != nil {
		//	e := errs.InvalidFormat(err.Error())
		//	httpx.WriteJsonCtx(r.Context(), w, e.HTTPStatus(), types.Status{
		//		Code:    int64(e.FullCode()),
		//		Message: err.Error(),
		//	})
		//
		//	return
		//}

		l := user.NewGetUserInfoLogic(r.Context(), svcCtx)
		resp, err := l.GetUserInfo(&req)
		if err != nil {
			e := errs.FromError(err)
			httpx.WriteJsonCtx(r.Context(), w, e.HTTPStatus(), types.Resp{
				Code:    e.DisplayCode(),
				Message: e.Error(),
				Error:   e.Unwrap(),
			})
		} else {
			httpx.WriteJsonCtx(r.Context(), w, http.StatusOK, resp)
		}
	}
}
